signature PEIRCE =
   sig  
        type set
  
        val ConS : string -> set
        val UnitS : set
        val ZeroS : set
        val SumS  : set * set -> set
        val ProdS : set * set -> set
        val CompS : set -> set

        type rel 
       
        val ConR : string -> rel
        val UnitR : rel
        val ZeroR : rel
        val SumR  : rel * rel -> rel
        val ProdR : rel * rel -> rel
        val CompR : rel -> rel

        val I     : rel
        val Conv  : rel -> rel
        val Prod  : rel * rel -> rel
        val Minor : rel -> rel
        val Tc    : rel -> rel
 
        val PreIm : rel * set -> set
        val Cylin : set -> rel

        type tv 

        val E : set -> tv
        val U : set -> tv
        val N : set -> tv

        val ER : rel -> tv
        val UR : rel -> tv
        val NR : rel -> tv

        val And : tv * tv -> tv                                 
        val Or  : tv * tv -> tv                                 
        val Neg : tv -> tv                                 
   end

signature SYN = 
   sig 
       datatype set = ConS of string 
                     | SumS of set * set
                     | ZeroS
                     | ProdS of set * set
                     | UnitS 
                     | CompS of set
                     | PreIm of rel * set   (* R : B *)
       and      rel = ConR of string
                     | SumR of rel * rel
                     | ZeroR
                     | ProdR of rel * rel
                     | UnitR
                     | CompR of rel
                     | Minor of rel
                     | Tc of rel
                     | Id of set
                     | Prod of rel * rel
                     | Conv of rel
                     | Cylin of set
       and      tv  = E of set
                     | N of set
                     | U of set
                     | ER of rel
                     | UR of rel
                     | NR of rel
                     | And of tv * tv
                     | Or of tv * tv
                     | Neg of tv

       val StoString : set -> string
       val RtoString : rel -> string
       val TtoString : tv -> string
   end

