signature NL__TOKENS =
  sig
include ABSYN
    type ('a,'b) token
    type svalue

    val UQ: 'a * 'a  -> (svalue,'a) token
    val NQ: 'a * 'a  -> (svalue,'a) token
    val EQ: 'a * 'a  -> (svalue,'a) token
    val Det: 'a * 'a  -> (svalue,'a) token
    val von: 'a * 'a  -> (svalue,'a) token
    val TVp: (rel) * 'a * 'a  -> (svalue,'a) token
    val IVp: (set) * 'a * 'a  -> (svalue,'a) token
    val CopVp: 'a * 'a  -> (svalue,'a) token
    val TVs: (rel) * 'a * 'a  -> (svalue,'a) token
    val IVs: (set) * 'a * 'a  -> (svalue,'a) token
    val CopVs: 'a * 'a  -> (svalue,'a) token
    val IAComp: (rel) * 'a * 'a  -> (svalue,'a) token
    val CAp: (set) * 'a * 'a  -> (svalue,'a) token
    val CAs: (set) * 'a * 'a  -> (svalue,'a) token
    val P: (rel) * 'a * 'a  -> (svalue,'a) token
    val RNp: (rel) * 'a * 'a  -> (svalue,'a) token
    val RNs: (rel) * 'a * 'a  -> (svalue,'a) token
    val CN: (set) * 'a * 'a  -> (svalue,'a) token
    val PN: (set) * 'a * 'a  -> (svalue,'a) token
    val PUNKT: 'a * 'a  -> (svalue,'a) token
    val EOF: 'a * 'a  -> (svalue,'a) token
  end

signature NL__VALS =
  sig
    structure Tokens : NL__TOKENS
    structure ParserData : PARSER_DATA
    sharing type ParserData.Token.token = Tokens.token
    sharing type ParserData.svalue = Tokens.svalue
  end

