signature NL__TOKENS =
  sig
include ABSYN
    type ('a,'b) token
    type svalue

    val UQa: 'a * 'a  -> (svalue,'a) token
    val NQa: 'a * 'a  -> (svalue,'a) token
    val EQa: 'a * 'a  -> (svalue,'a) token
    val UQd: 'a * 'a  -> (svalue,'a) token
    val NQd: 'a * 'a  -> (svalue,'a) token
    val EQd: 'a * 'a  -> (svalue,'a) token
    val UQg: 'a * 'a  -> (svalue,'a) token
    val NQg: 'a * 'a  -> (svalue,'a) token
    val EQg: 'a * 'a  -> (svalue,'a) token
    val UQn: 'a * 'a  -> (svalue,'a) token
    val NQn: 'a * 'a  -> (svalue,'a) token
    val EQn: 'a * 'a  -> (svalue,'a) token
    val Deta: 'a * 'a  -> (svalue,'a) token
    val Detd: 'a * 'a  -> (svalue,'a) token
    val Detg: 'a * 'a  -> (svalue,'a) token
    val Detn: 'a * 'a  -> (svalue,'a) token
    val von: 'a * 'a  -> (svalue,'a) token
    val TVp: (rel) * 'a * 'a  -> (svalue,'a) token
    val IVp: (set) * 'a * 'a  -> (svalue,'a) token
    val CopVp: 'a * 'a  -> (svalue,'a) token
    val TVs: (rel) * 'a * 'a  -> (svalue,'a) token
    val IVs: (set) * 'a * 'a  -> (svalue,'a) token
    val CopVs: 'a * 'a  -> (svalue,'a) token
    val CApa: (set) * 'a * 'a  -> (svalue,'a) token
    val CAsa: (set) * 'a * 'a  -> (svalue,'a) token
    val CApd: (set) * 'a * 'a  -> (svalue,'a) token
    val CAsd: (set) * 'a * 'a  -> (svalue,'a) token
    val CApg: (set) * 'a * 'a  -> (svalue,'a) token
    val CAsg: (set) * 'a * 'a  -> (svalue,'a) token
    val CApn: (set) * 'a * 'a  -> (svalue,'a) token
    val CAsn: (set) * 'a * 'a  -> (svalue,'a) token
    val RNpa: (rel) * 'a * 'a  -> (svalue,'a) token
    val RNsa: (rel) * 'a * 'a  -> (svalue,'a) token
    val CNa: (set) * 'a * 'a  -> (svalue,'a) token
    val RNpd: (rel) * 'a * 'a  -> (svalue,'a) token
    val RNsd: (rel) * 'a * 'a  -> (svalue,'a) token
    val CNd: (set) * 'a * 'a  -> (svalue,'a) token
    val RNpg: (rel) * 'a * 'a  -> (svalue,'a) token
    val RNsg: (rel) * 'a * 'a  -> (svalue,'a) token
    val CNg: (set) * 'a * 'a  -> (svalue,'a) token
    val RNpn: (rel) * 'a * 'a  -> (svalue,'a) token
    val RNsn: (rel) * 'a * 'a  -> (svalue,'a) token
    val CNn: (set) * 'a * 'a  -> (svalue,'a) token
    val IAComp: (rel) * 'a * 'a  -> (svalue,'a) token
    val P: (rel) * 'a * 'a  -> (svalue,'a) token
    val PN: (set) * 'a * 'a  -> (svalue,'a) token
    val PUNKT: 'a * 'a  -> (svalue,'a) token
    val EOF: 'a * 'a  -> (svalue,'a) token
  end

signature NL__VALS =
  sig
    structure Tokens : NL__TOKENS
    structure ParserData : PARSER_DATA
    sharing type ParserData.Token.token = Tokens.token
    sharing type ParserData.svalue = Tokens.svalue
  end

