signature SEM = sig 
                    type absyn 
                    type value 
                    val eval : absyn -> value 
                end

functor Semantics(structure A:ABSYN 
                  structure P:PEIRCEfull) : SEM where type absyn = A.absyn =
    struct
       datatype absyn = datatype A.absyn
       datatype value = nu of P.tv | un of P.set | bi of P.rel
                             
       fun eval(A.unary X) = un(evalS X) 
         | eval(A.binary X) = bi(evalR X)
         | eval(A.nullary X) = nu(evalT X) 
       and evalS(A.ConS s) = P.ConS s  
         | evalS(A.UnitS) = P.UnitS
         | evalS(A.ZeroS) = P.ZeroS
         | evalS(A.SumS(A,B)) = P.SumS(evalS A,evalS B)
         | evalS(A.ProdS(A,B)) = P.ProdS(evalS A,evalS B)
         | evalS(A.CompS A) = P.CompS(evalS A)
         | evalS(A.PreIm(R,A)) = P.PreIm(evalR R,evalS A)
       and evalR(A.ConR s) = P.ConR s 
         | evalR(A.Id A) = P.ProdR(P.I, P.Cylin(evalS A))
         | evalR(A.UnitR) = P.UnitR
         | evalR(A.ZeroR) = P.ZeroR
         | evalR(A.SumR(S,T)) = P.SumR(evalR S,evalR T)
         | evalR(A.ProdR(S,T)) = P.ProdR(evalR S,evalR T)
         | evalR(A.CompR T) = P.CompR(evalR T)
         | evalR(A.Minor T) = P.Minor(evalR T)
         | evalR(A.Tc T) = P.Tc(evalR T)
         | evalR(A.Conv T) = P.Conv(evalR T)
         | evalR(A.Prod(S,T)) = P.Prod(evalR S,evalR T)
         | evalR(A.Cylin A) = P.Cylin(evalS A)
       and evalT(A.E A) = P.E(evalS A)
         | evalT(A.U A) = P.U(evalS A)
         | evalT(A.N A) = P.N(evalS A)
         | evalT(A.ER A) = P.ER(evalR A)
         | evalT(A.UR A) = P.UR(evalR A)
         | evalT(A.NR A) = P.NR(evalR A)
         | evalT(A.And(A,B)) = P.And(evalT A,evalT B)
         | evalT(A.Or(A,B)) = P.Or(evalT A,evalT B)
         | evalT(A.Neg A) = P.Neg(evalT A)
    end 

