structure T = Tokens
structure I = Interface
structure A = Absyn

open I

type pos = I.pos
type svalue = T.svalue
type ('a,'b) token = ('a,'b) T.token
type lexresult = (svalue,pos) token list * string

fun eof() = ([T.EOF(!line,!line)],"")

fun CN(s:string) = ([T.CN(A.ConS s,!line,!line)],s)
fun RN(s:string) = ([T.RN(A.ConR s,!line,!line)],s)
fun PN(s:string) = ([T.PN(A.ConS s,!line,!line)],s)
fun IV(s:string) = ([T.IV(A.ConS s,!line,!line)],s)
fun TV(s:string) = ([T.TV(A.ConR s,!line,!line)],s)
fun CA(s:string) = ([T.CA(A.ConS s,!line,!line)],s)

%%  
%header (functor NL_LexFun(structure Absyn: ABSYN
                           structure Tokens: NL__TOKENS
                              sharing type Absyn.set = Tokens.set 
                           structure Interface: INTERFACE) : LEXER);
%full 

whitespace=[\t\ ]*;
%%
<INITIAL>{whitespace} => (lex());
\n         => (next_line(); lex());
"."        => ([T.PUNKT(!line,!line)],yytext);
"ist"      => ([T.CopV(!line,!line)],yytext);
("ein" | "eine") 
           => ([T.ein(!line,!line)],yytext);
"eines"    => ([T.eines(!line,!line)],yytext);
"einen"    => ([T.EQ(!line,!line)],yytext);
("keinen" | "kein" | "Kein" | "Keine" | "keine")   
           => ([T.NQ(!line,!line)],yytext);
("Alle" | "alle" | "Jeder" | "jeder" 
                 | "Jede" | "jede" | "Jeden" | "jeden")   
           => ([T.UQ(!line,!line)],yytext);
"Anna"     => (PN "Anna");
"Dieter"   => (PN "Dieter");
"Emil"     => (PN "Emil");
"Maria"    => (PN "Maria");
"Mann"     => (CN "Mann");
"Frau"     => (CN "Frau");
"Hund"     => (CN "Hund");
("Student" | "Studenten") 
           => (CN "Student");
"Nachbar"  => (RN "Nachbar");  
"Bruder"   => (RN "Bruder"); 
"gesund"   => (CA "gesund");
("arbeiten" | "arbeitet") => (IV "arbeiten");
("kennen" | "kennt")      => (TV "kennen");
("lieben" | "liebt")      => (TV "lieben");
.          => (error ("ignoring illegal character " ^ yytext,
                      !line,!line); lex());

